package org.dromara.elevator.service.impl;

import org.dromara.common.core.exception.ServiceException;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EElevatorUser;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EEmployInfoBo;
import org.dromara.elevator.domain.vo.EEmployInfoVo;
import org.dromara.elevator.domain.EEmployInfo;
import org.dromara.elevator.mapper.EEmployInfoMapper;
import org.dromara.elevator.service.IEEmployInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 使用单位基础信息;Service业务层处理
 *
 * @author zy
 * @date 2024-07-26
 */
@RequiredArgsConstructor
@Service
public class EEmployInfoServiceImpl implements IEEmployInfoService {

    private final EEmployInfoMapper baseMapper;

    /**
     * 查询使用单位基础信息;
     *
     * @param id 主键
     * @return 使用单位基础信息;
     */
    @Override
    public EEmployInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询使用单位基础信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 使用单位基础信息;分页列表
     */
    @Override
    public TableDataInfo<EEmployInfoVo> queryPageList(EEmployInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EEmployInfo> lqw = buildQueryWrapper(bo);
        Page<EEmployInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的使用单位基础信息;列表
     *
     * @param bo 查询条件
     * @return 使用单位基础信息;列表
     */
    @Override
    public List<EEmployInfoVo> queryList(EEmployInfoBo bo) {
        LambdaQueryWrapper<EEmployInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EEmployInfo> buildQueryWrapper(EEmployInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EEmployInfo> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getOrganizationId()), EEmployInfo::getOrganizationId, bo.getOrganizationId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), EEmployInfo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getContacts()), EEmployInfo::getContacts, bo.getContacts());
        lqw.eq(StringUtils.isNotBlank(bo.getContactsPhone()), EEmployInfo::getContactsPhone, bo.getContactsPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getAreaCode()), EEmployInfo::getAreaCode, bo.getAreaCode());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), EEmployInfo::getAddress, bo.getAddress());
        lqw.orderByDesc(EEmployInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增使用单位基础信息;
     *
     * @param bo 使用单位基础信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EEmployInfoBo bo) {
        EEmployInfo add = MapstructUtils.convert(bo, EEmployInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改使用单位基础信息;
     *
     * @param bo 使用单位基础信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EEmployInfoBo bo) {
        EEmployInfo update = MapstructUtils.convert(bo, EEmployInfo.class);
        validEntityBeforeUpdate(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EEmployInfo entity){
        //TODO 做一些数据校验,如唯一约束
        LambdaQueryWrapper<EEmployInfo> num = Wrappers.lambdaQuery();
        num.eq(StringUtils.isNotBlank(entity.getCode()), EEmployInfo::getCode, entity.getCode());
        List<EEmployInfoVo> infoVoList = baseMapper.selectVoList(num);
        if (!infoVoList.isEmpty()) {
            throw new ServiceException("该使用单位编号已存在!");
        }
    }

    /**
     * 更新前的数据校验
     */
    private void validEntityBeforeUpdate(EEmployInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除使用单位基础信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }

    @Override
    public EEmployInfoVo selectByCode(String code) {
        return baseMapper.selectVoOne(new LambdaQueryWrapper<EEmployInfo>().eq(EEmployInfo::getCode, code));
    }
}
